MantisBT

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0007105ardourbugspublic2016-11-12 14:112017-03-11 03:34
Reporterunfa 
Assigned Totimbyr 
PrioritynormalSeverityminorReproducibilityhave not tried
StatusresolvedResolutionfixed 
PlatformGNU/Linux AMD 64OSLinux MintOS Version18 KDE5
Product Version5.4 
Target VersionFixed in Version 
Summary0007105: Linked MIDI regions shift notes when resizing
DescriptionI think I know why this is happening.

When resizing linked MIDI regions - the regions is increasing in size so that the first note has more space between itself and the start of the region - room where new notes can be inserted. The problem is, the other linked regions should compensate for that to keep their notes in place - instead they shift their notes.
Steps To Reproduce1. Create MIDI region on a MIDI track and put some notes in it.
2. Duplicate that region onto the same MIDI track (drag & drop while holding Ctrl)
3. Resize the duplicated region's start to the left.
4. The original MIDI regions's notes will shift to the right - breaking sync with the track.
TagsNo tags attached.
Attached Files? file icon Ardour-5.8.73-test-bug-7105.webm [^] (383,413 bytes) 2017-03-05 16:19

- Relationships

-  Notes
(0018946)
timbyr (developer)
2016-11-12 16:21

I can confirm this issue in 5.4 and 5.4.320 nightly.

This behaviour seems incorrect to me, the offset of the MIDI events from region start within a region should be independent even for linked regions if that is possible or if not then region should automatically become unlinked. I can't think of a situation where the current behaviour would ever be intentional.

I also notice that it seems to increase the offset if you move the region start earlier on the timeline but it won't change the offset back when you move the region start position back to the original position.
(0018973)
nick_m (reporter)
2016-11-16 04:13

this is due to the trim operation extending the source start to the region
start.
see MidiRegion::fix_negative_start()

it should be possible to remove this.
(0018974)
nick_m (reporter)
2016-11-16 04:28

so if se reset the start for all regions using the same source, it should work.
i think the problem is that the other regions don't know that their source has been resized.
(0019461)
nick_m (reporter)
2017-03-03 16:35

this should be fixed by commit e8b5b4fcf3.

can you test?

thanks
(0019483)
timbyr (developer)
2017-03-04 17:03

It seems to work as expected but I have noticed and issue with undo.

If you copy (linked) a MIDI region and trim/move the start position to the left past original region start then the first region doesn't change as it used to, but undo at that point will change note offset in the original region.
(0019487)
nick_m (reporter)
2017-03-05 06:04

this bug only appears if a region that uses the same source is on another playlist.

it should be fixed by commit a445e8277640

please test region start trim undo for audio and midi regions and combinations of
multiple track region start trims.
(0019490)
timbyr (developer)
2017-03-05 16:19

There still seems to be an issue with undo after commit, I've attached a video to capture what I'm seeing.
(0019493)
nick_m (reporter)
2017-03-05 20:53

does commit 16089bff96a13b8 fix it?

thanks
(0019494)
timbyr (developer)
2017-03-05 22:43

It now seems to work as expected without any issues after a little testing in version 5.8.76(16089bff96)

I'll do some further testing and if I can't find any issues with it I'll mark it as resolved.
(0019522)
timbyr (developer)
2017-03-11 03:34

I spent a bit more time testing this (with 5.8.116) and it does seem to always work correctly with undo/redo etc. Marking as resolved.

- Issue History
Date Modified Username Field Change
2016-11-12 14:11 unfa New Issue
2016-11-12 16:21 timbyr Note Added: 0018946
2016-11-12 16:21 timbyr Status new => confirmed
2016-11-16 04:13 nick_m Note Added: 0018973
2016-11-16 04:28 nick_m Note Added: 0018974
2017-03-03 16:35 nick_m Note Added: 0019461
2017-03-03 16:52 timbyr Status confirmed => feedback
2017-03-04 17:03 timbyr Note Added: 0019483
2017-03-05 06:04 nick_m Note Added: 0019487
2017-03-05 16:19 timbyr Note Added: 0019490
2017-03-05 16:19 timbyr File Added: Ardour-5.8.73-test-bug-7105.webm
2017-03-05 20:53 nick_m Note Added: 0019493
2017-03-05 22:43 timbyr Note Added: 0019494
2017-03-11 03:34 timbyr Note Added: 0019522
2017-03-11 03:34 timbyr Status feedback => resolved
2017-03-11 03:34 timbyr Resolution open => fixed
2017-03-11 03:34 timbyr Assigned To => timbyr


Copyright © 2000 - 2017 MantisBT Team
Powered by Mantis Bugtracker